<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelProdModTipocons  {

    protected $elProdModTipocons;
    protected $utilService;
    
    public function __construct(Services\RelProdModTipocons $elProdModTipocons, Utilities\Util $utilService) {
        $this->relProdModTipocons = $elProdModTipocons;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        ini_set('max_execution_time', 3600);
        ini_set('memory_limit', '1G');
        set_time_limit(3600);
        
        $result = [];
        
        $conditions = $this->utilService->getParamsAsArray($request);
        $conditions = $this->relProdModTipocons->buildParamsFaturamento($conditions);
        
        if(isset($conditions['DATAINI']) && !empty($conditions['DATAINI']) && isset($conditions['DATAFIN']) && !empty($conditions['DATAFIN'])) {
            $result = $this->relProdModTipocons->find($conditions);
        }
        
        $response->addDataSet(new DataSet("vnd55020_relProdModTipocons", $result));
        
        return $response;
    }
}
