<?php
namespace Teknisa\MAN\Controllers;

use \Teknisa\Libs\Utilities\Environment;
use Teknisa\MAN\Utilities\Util;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Services\UnidadeService;

class Unidade extends \Teknisa\MAN\Controllers\TeknisaCrud {

    public $dataSourceName = "filial_filioper";
    protected $parameterBagColumns = ["NRORG", "CDOPERADOR", "PERFIL"];
    protected $environment;
    protected $util;
    
    public function __construct($util, $environment, $crudService, $parameterBag, UnidadeService $unidade) {
        $this->environment = $environment;
        $this->util = $util;
        $this->unidadeService = $unidade;
        parent::__construct($crudService, $parameterBag);
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $filterCriteria = $request->getFilterCriteria();
        $rows = $this->util->getParamsAsArray($request);
        $conditions = $filterCriteria->getConditions();
        $operadorCondition = array_filter($conditions, function($item) {
            return strtoupper($item['columnName']) == 'CDOPERADOR';
        });
        if ($operadorCondition == null) {
            $filterCriteria->addCondition("CDOPERADOR", "OPERADOR_LOGADO");
        }
        if($this->environment->getIdUtlPerfilFilial() == 'S'){
            $rows['NRPERFIL'] = $this->environment->getNrPerfil();
            $filterCriteria->addCondition("PERFIL", $rows['NRPERFIL']);
            $this->dataSourceName = 'filial_perfil' ;
        } else {
            $this->dataSourceName = 'filial_filioper' ;
        }
        parent::find($request, $response);
    }
}
